/*
 * Copyright (c) 2018 Atmosphère-NX
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
#include <switch.h>
#include <stratosphere.hpp>
#include "pm_boot_mode.hpp"

static bool g_is_maintenance_boot = false;

void BootModeService::GetBootMode(Out<u32> out) {
    out.SetValue(g_is_maintenance_boot);
}

void BootModeService::SetMaintenanceBoot() {
    g_is_maintenance_boot = true;
}

void BootModeService::SetMaintenanceBootForEmbeddedBoot2() {
    g_is_maintenance_boot = true;
}
